// Color Fusion
// tULAMIDE
// PS 1.4
// Tone Shader

//#PARAM float chRed 192: Red : The red channel of the color.
float chRed;

//#PARAM float chGreen 136: Green : The green channel of the color.
float chGreen;

//#PARAM float chBlue 120: Blue : The blue channel of the color.
float chBlue;

//#PARAM percent cIntensity 0.7: Intensity : The strength of the color.
float cIntensity;

// Foreground texture
texture ForegroundTexture;

// Foreground sampler
sampler2D foreground = sampler_state {
    Texture = (ForegroundTexture);
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = Linear;
};

//Tinting 
float3 ctint(float3 ocolor, float3 tintcolor, float strength)
{	
	float grey = (ocolor.r + ocolor.g + ocolor.b) / 3;
        
	float nRed = (1.0f - strength) * ocolor.r + (strength * tintcolor.r * grey);
	float nGrn = (1.0f - strength) * ocolor.g + (strength * tintcolor.g * grey);
	float nBlu = (1.0f - strength) * ocolor.b + (strength * tintcolor.b * grey);
        
	return float3(nRed, nGrn, nBlu);
}

// Effect function
float4 EffectProcess( float2 Tex : TEXCOORD0 ) : COLOR0
{
	float4 color = tex2D(foreground, Tex.xy);
	
	color.rgb /= color.a;
	color.rgb = ctint(color.rgb, float3(chRed/255, chGreen/255, chBlue/255), cIntensity);
	color.rgb *= color.a;
	return color;
}
	
// ConstructEffect
technique ConstructEffect
{
    pass p0
    {
        VertexShader = null;
        PixelShader = compile ps_2_0 EffectProcess();
    }
}
