// Sharpen
// Paulo Ricardo Reinehr
// PS 2.0
// Simple sharpen with intensity control.


//#PARAM percent intensity 1 : Intensity : Sharpen intensity.
float intensity;


// Foreground texture
texture ForegroundTexture;

// Foreground sampler
sampler2D foreground = sampler_state {
    Texture = (ForegroundTexture);
    MinFilter = Point;
    MagFilter = Point;
    MipFilter = Point;
};


float pixelWidth;
float pixelHeight;


// Effect function
float4 EffectProcess( float2 Tex : TEXCOORD0 ) : COLOR0
{

	float4 color = tex2D( foreground , Tex.xy );
	float3 blur = color ;
	blur += tex2D( foreground , Tex.xy + float2( -pixelWidth , -pixelHeight ));
	blur += tex2D( foreground , Tex.xy + float2( 0 , -pixelHeight ));
	blur += tex2D( foreground , Tex.xy + float2( pixelWidth , -pixelHeight ));
	blur += tex2D( foreground , Tex.xy + float2( -pixelWidth , 0 ));
	blur += tex2D( foreground , Tex.xy + float2( pixelWidth , 0 ));
	blur += tex2D( foreground , Tex.xy + float2( -pixelWidth , pixelHeight ));
	blur += tex2D( foreground , Tex.xy + float2( 0 , pixelHeight ));
	blur += tex2D( foreground , Tex.xy + float2( pixelWidth , pixelHeight ));

	blur /= 9 ;

	color.rgb -= ( (blur.r - color.r) + (blur.g - color.g) + (blur.b - color.b) ) / 3 ;

	color = color * intensity + (1.0 - intensity) * tex2D( foreground , Tex.xy );

	return color;
}

// ConstructEffect
technique ConstructEffect
{
    pass p0
    {
        VertexShader = null;
        PixelShader = compile ps_2_0 EffectProcess();
    }
}